libzypp: zypp::sat::ArrayAttr< TResult, TAttr > Class Template Reference

libzypp 17.36.6

Public Types | Public Member Functions | Private Attributes | Friends | List of all members
zypp::sat::ArrayAttr< TResult, TAttr > Class Template Reference

LookupAttr::TransformIterator based container to retrieve list attributes. More...

`#include <zypp/sat/LookupAttrTools.h>`

## Public Types
using | iterator = LookupAttr::TransformIterator<TResult, TAttr>
using | size_type = LookupAttr::size_type

## Public Member Functions
| ArrayAttr ()
| ArrayAttr (SolvAttr attr_r, LookupAttr::Location loc_r=LookupAttr::SOLV_ATTR)
| ArrayAttr (SolvAttr attr_r, Repository repo_r, LookupAttr::Location loc_r=LookupAttr::SOLV_ATTR)
| ArrayAttr (SolvAttr attr_r, Solvable solv_r)
iterator | begin () const
iterator | end () const
bool | empty () const
size_type | size () const
iterator | find (const TResult &key_r) const

## Private Attributes
LookupAttr | _q

## Friends
std::ostream & | operator (std::ostream &str, const ArrayAttr< TResult, TAttr > &obj)

## Detailed Description

template<class TResult, class TAttr>
class zypp::sat::ArrayAttr< TResult, TAttr >

LookupAttr::TransformIterator based container to retrieve list attributes.

You may pass LookupAttr::REPO_ATTR as LookupAttr::Location argument, to lookup attributes associated with the Repository as a whole (e.g. repository keywords).

See also
  LookupAttr for details.

typedef ArrayAttr<PackageKeyword,IdString> Keywords;
Keywords k( sat::SolvAttr::keywords );
dumpRange( MIL << "All Keywords: ", k.begin(), k.end() ) << endl;
zypp::sat::ArrayAttr::ArrayAttr
ArrayAttr()
Definition LookupAttrTools.h:161
zypp::sat::SolvAttr::keywords
static const SolvAttr keywords
Definition SolvAttr.h:115
zypp::dumpRange
std::ostream & dumpRange(std::ostream &str, TIterator begin, TIterator end, const std::string &intro="{", const std::string &pfx="\n ", const std::string &sep="\n ", const std::string &sfx="\n", const std::string &extro="}")
Print range defined by iterators (multiline style).
Definition LogTools.h:120
MIL
#define MIL
Definition Logger.h:100

Todo
  Maybe add some way to unify the result.

Definition at line 156 of file LookupAttrTools.h.

## Member Typedef Documentation

## ◆ iterator

template<class TResult, class TAttr>

using zypp::sat::ArrayAttr< TResult, TAttr >::iterator = LookupAttr::TransformIterator<TResult, TAttr>

Definition at line 177 of file LookupAttrTools.h.

## ◆ size_type

template<class TResult, class TAttr>

using zypp::sat::ArrayAttr< TResult, TAttr >::size_type = LookupAttr::size_type

Definition at line 178 of file LookupAttrTools.h.

## Constructor & Destructor Documentation

## ◆ ArrayAttr() [1/4]

template<class TResult, class TAttr>

zypp::sat::ArrayAttr< TResult, TAttr >::ArrayAttr | ( |  | ) |
| inline

Definition at line 161 of file LookupAttrTools.h.

## ◆ ArrayAttr() [2/4]

template<class TResult, class TAttr>

zypp::sat::ArrayAttr< TResult, TAttr >::ArrayAttr | ( | SolvAttr | attr_r,
|  | LookupAttr::Location | loc_r = LookupAttr::SOLV_ATTR )
| inline

Definition at line 164 of file LookupAttrTools.h.

## ◆ ArrayAttr() [3/4]

template<class TResult, class TAttr>

zypp::sat::ArrayAttr< TResult, TAttr >::ArrayAttr | ( | SolvAttr | attr_r,
|  | Repository | repo_r,
|  | LookupAttr::Location | loc_r = LookupAttr::SOLV_ATTR )
| inline

Definition at line 168 of file LookupAttrTools.h.

## ◆ ArrayAttr() [4/4]

template<class TResult, class TAttr>

zypp::sat::ArrayAttr< TResult, TAttr >::ArrayAttr | ( | SolvAttr | attr_r,
|  | Solvable | solv_r )
| inline

Definition at line 172 of file LookupAttrTools.h.

## Member Function Documentation

## ◆ begin()

template<class TResult, class TAttr>

iterator zypp::sat::ArrayAttr< TResult, TAttr >::begin | ( |  | ) | const
| inline

Definition at line 180 of file LookupAttrTools.h.

## ◆ end()

template<class TResult, class TAttr>

iterator zypp::sat::ArrayAttr< TResult, TAttr >::end | ( |  | ) | const
| inline

Definition at line 183 of file LookupAttrTools.h.

## ◆ empty()

template<class TResult, class TAttr>

bool zypp::sat::ArrayAttr< TResult, TAttr >::empty | ( |  | ) | const
| inline

Definition at line 186 of file LookupAttrTools.h.

## ◆ size()

template<class TResult, class TAttr>

size_type zypp::sat::ArrayAttr< TResult, TAttr >::size | ( |  | ) | const
| inline

Definition at line 189 of file LookupAttrTools.h.

## ◆ find()

template<class TResult, class TAttr>

iterator zypp::sat::ArrayAttr< TResult, TAttr >::find | ( | const TResult & | key_r | ) | const
| inline

Definition at line 199 of file LookupAttrTools.h.

## Friends And Related Symbol Documentation

## ◆ operator

template<class TResult, class TAttr>

std::ostream & operator | ( | std::ostream & | str,
|  | const ArrayAttr< TResult, TAttr > & | obj )
| friend

## Member Data Documentation

## ◆ _q

template<class TResult, class TAttr>

LookupAttr zypp::sat::ArrayAttr< TResult, TAttr >::_q
| private

Definition at line 210 of file LookupAttrTools.h.

The documentation for this class was generated from the following files:

- zypp/sat/LookupAttr.h
- zypp/sat/LookupAttrTools.h